// LetterFunction.cpp: LetterFunction NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PolyTest.h"
#include "LetterFunction.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

LetterFunction::LetterFunction()
{
	CString file_name = "C:\\nenga\\horiS.pgm";
	int i,j;
	int k, kk;
	char buffer[10];
	FILE *ipst;  /* InPut STream */

	ipst = fopen(file_name, "r");
	if (!ipst){
		fprintf(stderr, "Can't open the pgm file %s\n", buffer);
		exit(0);
	}

	fscanf(ipst,"%s",buffer);

	/* skip comment lines if exists */
	k = getc(ipst);
	while ((kk=getc(ipst)) == '#') {
		i = -1;
		fprintf(stderr,"\nfile = ");
		do {
			i++;
			k = getc(ipst);
        }while (k != '\n');
    }
	if (kk != '#') ungetc(kk,ipst);
  
	fscanf(ipst,"%d",&sizeX);
	fscanf(ipst,"%d",&sizeY);

	/* 摜̎,  */
	Z = new bool*[sizeY];
	for(i=0; i<sizeY; i++)
		Z[i] = new bool[sizeX];

	int max;
	fscanf(ipst,"%d",&max);

	/* pgmt@C̃XybN\ */
	//fprintf(stderr, "Magic number: %s", buffer);
	//fprintf(stderr, "\nResolution: %d x %d", img->width, img->height);
	//fprintf(stderr, "\nThe number of pixels: %d", img->pixels);
    
	/* Pxl̓ǂݍ */
	if (buffer[1] == '5'){
		/* P5t@CioCif[^j̓ǂݍ */
		unsigned char* tmp = new unsigned char[sizeY*sizeX];
		fread(tmp, sizeof(unsigned char), sizeY*sizeX, ipst);

		for(i=0; i<sizeY; i++){
			for(j=0; j<sizeX; j++){
				if(tmp[i*sizeX+j] != 255)
					Z[i][j] = true;
				else
					Z[i][j] = false;
				//image->I[i][j] = 255.0f*(float)tmp[i*sizeX+j]/(float)max;
			}
		}
		delete[] tmp;

		//for (i = 0; i < img->pixels; i++)
			//fread(img->I, sizeof(pixel), img->pixels, ipst);
    }
	
	//else {
		/* P2t@CiAXL[f[^j̓ǂݍ */
	/*
		for(int i=0; i<sizeY; i++)
			for(int j=0; j<sizeX; j++){
				int data;
				fscanf(ipst, "%d", &data);
				image->I[i][j] = (float)data*255.0f/(float)max;;
			}*/
		//for (i = 0; i < img->pixels; i++){
			//fscanf(ipst, "%d", &integer_value);
			//img->I[i] = integer_value;
        //}
    //}
	fclose(ipst);
	//free(ipst);
}

LetterFunction::~LetterFunction()
{

}

float LetterFunction::EvaluateFunction(float x[])
{
	int x1 = (int)x[0];
	int y1 = (int)x[1];

	double f = -10000000;
	for(int i=y1-11; i<y1+11; i++){
		if(i < 1 || i >= sizeY)
			continue;
		for(int j=x1-11; j<x1+11; j++){
			if(j < 1 || j >= sizeX)
				continue;	
			if(Z[i][j]){
				f = max(f, 100 - (x[0]-(double)j)*(x[0]-(double)j) - (x[1]-(float)i)*(x[1]-(float)i) - x[2]*x[2]);
			}
		}
	}
	TRACE("%f,%f,%f\n", x[0], x[1],x[2]);
	return f;
}

void LetterFunction::EvaluateGradient(float x[], float g[])
{
	float p1[3], p2[3];

	p1[0] = x[0] - h; 
	p1[1] = x[1];
	p1[2] = x[2];
	
	p2[0] = x[0] + h; 
	p2[1] = x[1];
	p2[2] = x[2];

	g[0] = (EvaluateFunction(p2) - EvaluateFunction(p1))/(2.0f*h);

	p1[0] = x[0]; 
	p1[1] = x[1] - h;
	p1[2] = x[2];
	
	p2[0] = x[0]; 
	p2[1] = x[1] + h;
	p2[2] = x[2];

	g[1] = (EvaluateFunction(p2) - EvaluateFunction(p1))/(2.0f*h);

	p1[0] = x[0]; 
	p1[1] = x[1];
	p1[2] = x[2] - h;
	
	p2[0] = x[0]; 
	p2[1] = x[1];
	p2[2] = x[2] + h;

	g[2] = (EvaluateFunction(p2) - EvaluateFunction(p1))/(2.0f*h);
}
