// OurImplicitFunction.h: OurImplicitFunction NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OURIMPLICITFUNCTION_H__50BC97FE_B8F0_4A62_9AE7_F320256753CF__INCLUDED_)
#define AFX_OURIMPLICITFUNCTION_H__50BC97FE_B8F0_4A62_9AE7_F320256753CF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "vtkImplicitFunction.h"
#include "MeshData.h"
#include <math.h>

#define h 0.0001

class OurImplicitFunction : public vtkImplicitFunction  
{

public:
	int count;

public:
	inline float distanceToTriangle(float A[], float B[], float C[], float P[]);
	void doubleNabla(float x[], float dd[][3]);
	void nabla(float x[3], float g[3]);
	float model(float x[3]);
	void EvaluateDD(float x[3], float dd[3][3]);
	inline float metaball(float r, float d);
	inline float distanceToSegment(float A[], float B[], float P[]);
	float hfSphere(float x[3], float cen[3], float r);
	float hfTorusX(float x[3], float cen[3], float R, float r);
	float hfTorusZ(float x[3], float cen[3], float R, float r);
	float hfTorusY(float x[3], float cen[3], float R, float r);
	float hfEllCylZ(float x[3], float cen[3], float a, float b);
	float hfEllipsoid(float x[3], float cen[3], float a, float b, float c);
	float EvaluateFunction(float x[3]);
	void EvaluateGradient(float x[3], float g[3]);
	OurImplicitFunction();
	virtual ~OurImplicitFunction();
private:
	float R_uni(float f1, float f2);
	float R_int(float f1, float f2);
};

#endif // !defined(AFX_OURIMPLICITFUNCTION_H__50BC97FE_B8F0_4A62_9AE7_F320256753CF__INCLUDED_)
