// PolyTestView.cpp : CPolyTestView NX̓̒`s܂B
//

#include "stdafx.h"
#include "PolyTest.h"

#include "PolyTestDoc.h"
#include "PolyTestView.h"

#include <gl\gl.h>
#include <gl\glu.h>
#include <math.h>

//#define PI 3.14159265

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPolyTestView

IMPLEMENT_DYNCREATE(CPolyTestView, CView)

BEGIN_MESSAGE_MAP(CPolyTestView, CView)
	//{{AFX_MSG_MAP(CPolyTestView)
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_CREATE()
	ON_WM_RBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_KEYDOWN()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPolyTestView NX̍\z/

CPolyTestView::CPolyTestView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB
	eye[0] = 26;
	eye[1] = -48;
	eye[2] = 40;

	center[0] = 0.0;
	center[1] = 0.0;
	center[2] = 0.0; //10.0;

	//Rx = 0;
	//Ry = -462;
	//Rz = 209;

	//Ry = -564;
	//Rz = -57;

	//bunny
	//Ry = -928;
	//Rz = 312;

	//Rx = -132;
	//Ry = 121;
	//Rz = 543;

	
	Rx = 0;
	Ry = 22;
	Rz = -245;
	
	/*
	Rx = 0;
	Ry = -45;
	Rz = 134;
	*/
	
	vx[0] = 0;
	vx[1] = 0;
	vx[2] = 1;

	vy[0] = -(float)(eye[1]/sqrt(eye[0]*eye[0]+eye[1]*eye[1]));
	vy[1] = (float)(eye[0]/sqrt(eye[0]*eye[0]+eye[1]*eye[1]));
	vy[2] = 0;

	vz[0] = -vy[1];
	vz[1] = vy[0];
	vz[2] = 0;

	//view_angle = 25.0f;
	//view_angle = 8.65;

	view_angle = 22.5;

	isLPressed = FALSE;
	isRPressed = FALSE;

	shift_x = 0;
	shift_y = 0;
	shift_z = 0;

	f_err = 0;
	v_err = 0;

	face_N = 0;
	vertex_N = 0;
}

CPolyTestView::~CPolyTestView()
{
}

BOOL CPolyTestView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB
	cs.style |= WS_CLIPCHILDREN | WS_CLIPSIBLINGS;
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CPolyTestView NX̕`

void CPolyTestView::OnDraw(CDC* pDC)
{
	CPolyTestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B

	wglMakeCurrent(pDC->m_hDC, m_hRC);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

TRACE("%f, %f\n", Ry, Rz);
//TRACE("%f\n", view_angle);

	glPushMatrix();
	glTranslatef(shift_x,shift_y,shift_z);
	//glTranslatef(0,0,10);
	glRotatef(Rx,vz[0],vz[1],vz[2]);
	glRotatef(Ry,vy[0],vy[1],vy[2]);
	glRotatef(Rz,vx[0],vx[1],vx[2]);
	
	//glTranslatef(0,0,-10);
	//glCallList(1);
	pDoc->drawMesh();
	//drawBoundBox();
	glPopMatrix();

	glFlush();
	SwapBuffers(wglGetCurrentDC());
	wglMakeCurrent(pDC->m_hDC, NULL);

	pDC->SetBkColor(RGB(255,255,255));
	pDC->SetTextColor(RGB(0,0,0));
	


	//int v = pDoc->current_vertex_N;
	CString str;
	//for(int i=v; i!= 0; i = i/10)
		//str = (char)((int)'0'+i%10) + str;
	str.Format("%d", vertex_N);
	pDC->TextOut(8,8,"Vertex:" +  str);
	//v = pDoc->current_face_N;
	//for(i=v; i!= 0; i = i/10)
		//str = (char)((int)'0'+i%10) + str;
	str.Format("%d", face_N);
	pDC->TextOut(8,25,"Face  :" +  str);

	
	str.Format("%f", v_err);
	pDC->TextOut(8,42,"Vertex error:" +  str);

	str.Format("%f", f_err);
	pDC->TextOut(8,59,"Face error:  " +  str);
	

	//TRACE("%f,%f\n", Ry, Rz); 
}

/////////////////////////////////////////////////////////////////////////////
// CPolyTestView NX̐ff

#ifdef _DEBUG
void CPolyTestView::AssertValid() const
{
	CView::AssertValid();
}

void CPolyTestView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CPolyTestDoc* CPolyTestView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPolyTestDoc)));
	return (CPolyTestDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPolyTestView NX̃bZ[W nh

void CPolyTestView::flatShade(MeshData *mesh)
{
	//CClientDC clientDC(this);
	//wglMakeCurrent(clientDC.m_hDC, m_hRC);

	//glNewList(1, GL_COMPILE);
	glShadeModel(GL_SMOOTH);

	int face_N = mesh->face_N;
	int (*face)[3] = mesh->face;
	float (*normal_f)[3] = mesh->normal_f;
	float (*vertex)[3] = mesh->vertex;
	for(int i=0; i<face_N; i++){
		if(face[i][0] < 0)
			continue;
		glBegin(GL_POLYGON);
			glNormal3fv(normal_f[i]);
			glVertex3fv(vertex[face[i][0]]);
			glVertex3fv(vertex[face[i][1]]);
			glVertex3fv(vertex[face[i][2]]);
		glEnd();
	}

	/*
	glDisable(GL_LIGHTING);
	glColor3f(0.0,0.0,0.0);
	glLineWidth(2.0f);
	int (*ad_face)[3] = mesh->face_link_E;
	for(i=0; i<face_N; i++){
		if(face[i][0] < 0)
			continue;
		for(int j=0; j<3; j++){
			if(ad_face[i][j] < 0){
				glBegin(GL_LINES);
					glNormal3fv(normal_f[i]);
					glVertex3fv(vertex[face[i][j]]);
					glVertex3fv(vertex[face[i][(j+1)%3]]);
				glEnd();
			}
		}
	}
	glEnable(GL_LIGHTING);
	*/

	//glEndList();

	//wglMakeCurrent(clientDC.m_hDC, NULL);
}

void CPolyTestView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	int i;
	GLdouble up[3];
	GLdouble vector[3];
	GLdouble norm;

	CClientDC clientDC(this);

	wglMakeCurrent(clientDC.m_hDC, m_hRC);

	glViewport(0, 0, cx, cy);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	//gluPerspective(3, (GLfloat)cx/(GLfloat)cy, 10.0, 4000.0);
	gluPerspective(view_angle, (GLfloat)cx/(GLfloat)cy, 10.0, 4000.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	for(i=0; i<3; i++)
		vector[i] = center[i] - eye[i];

	up[0] =  vector[0] * vector[2];
	up[1] =  vector[1] * vector[2];
	up[2] =  vector[0] * vector[0] + vector[1] * vector[1];

	norm = up[0] * up[0] + up[1] * up[1] + up[2] * up[2];
	norm = sqrt(norm);
	for(i=0; i<3; i++)
		up[i] = up[i] / norm;
	
	gluLookAt(eye[0], eye[1], eye[2], center[0], center[1], center[2],
		up[0], up[1], up[2]);

	wglMakeCurrent(clientDC.m_hDC, NULL);	
}


void CPolyTestView::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	wglDeleteContext(m_hRC);
}

int CPolyTestView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ
	PIXELFORMATDESCRIPTOR pfd =
	{
		sizeof(PIXELFORMATDESCRIPTOR),
		1,
		PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,
		PFD_TYPE_RGBA,
		16,
		0,0,0,0,0,0,
		0,0,0,0,0,0,0,
		32,
		0,0,
		PFD_MAIN_PLANE,
		0,
		0,0,0
	};

	CClientDC  clientDC(this);

	int pixelFormat = ChoosePixelFormat(clientDC.m_hDC, &pfd);
	if(!SetPixelFormat(clientDC.m_hDC, pixelFormat, &pfd))
		return -1;

	m_hRC = wglCreateContext(clientDC.m_hDC);

	wglMakeCurrent(clientDC.m_hDC,m_hRC);
	initGL();
	wglMakeCurrent(clientDC.m_hDC,NULL);
	return 0;
}


void CPolyTestView::initGL()
{
	GLfloat light_position1[4] = {-52, -16, -50, 0};
	GLfloat light_position2[4] = {-26, -48, -50, 0};
	GLfloat light_position3[4] = { 16, -52, -50, 0};

	GLfloat direction1[3] = {52,16,50};
	GLfloat direction2[3] = {26,48,50};
	GLfloat direction3[3] = {-16,52,50};

	GLfloat light_position4[4] = {52, 16, 50, 0};
	GLfloat light_position5[4] = {26, 48, 50, 0};
	GLfloat light_position6[4] = {-16, 52, 50, 0};

	GLfloat direction4[3] = {-52,-16,-50};
	GLfloat direction5[3] = {-26,-48,-50};
	GLfloat direction6[3] = {16,-52,-50};

	GLfloat color1[4] = {1,0,0,1};
	GLfloat color2[4] = {0,1,0,1};
	GLfloat color3[4] = {0,0,1,1};

	GLfloat color4[4] = {1,0,0,1};
	GLfloat color5[4] = {0,1,0,1};
	GLfloat color6[4] = {0,0,1,1};
	
	/*
	GLfloat color1[4] = {0.7,0.7,0.7,0.7};
	GLfloat color2[4] = {0.7,0.7,0.7,0.7};
	GLfloat color3[4] = {0.7,0.7,0.7,0.7};

	GLfloat color4[4] = {0.7,0.7,0.7,0.7};
	GLfloat color5[4] = {0.7,0.7,0.7,0.7};
	GLfloat color6[4] = {0.7,0.7,0.7,0.7};
	*/
	
	GLfloat ambient[4] = {0.3f,0.3f,0.3f,0.5f};

	GLfloat material_color[4] = {1,1,1,1.0};
	GLfloat material_specular[4] = {0.5,0.5,0.5,0.5};
	GLfloat material_ambient[4] = {0.0,0.0,0.0,0.0};

	glClearColor(1,1,1,0);
	//glClearColor(0,0,0,0);

	glLightfv(GL_LIGHT0, GL_POSITION, light_position1);
	glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, direction1);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, color1);
	glLightfv(GL_LIGHT0, GL_SPECULAR, color1);

	glLightfv(GL_LIGHT1, GL_POSITION, light_position2);
	glLightfv(GL_LIGHT1, GL_SPOT_DIRECTION, direction2);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, color2);
	glLightfv(GL_LIGHT1, GL_SPECULAR, color2);

	glLightfv(GL_LIGHT2, GL_POSITION, light_position3);
	glLightfv(GL_LIGHT2, GL_SPOT_DIRECTION, direction3);
	glLightfv(GL_LIGHT2, GL_DIFFUSE, color3);
	glLightfv(GL_LIGHT2, GL_SPECULAR, color3);

	glLightfv(GL_LIGHT3, GL_POSITION, light_position4);
	glLightfv(GL_LIGHT3, GL_SPOT_DIRECTION, direction4);
	glLightfv(GL_LIGHT3, GL_DIFFUSE, color4);
	glLightfv(GL_LIGHT3, GL_SPECULAR, color4);

	glLightfv(GL_LIGHT4, GL_POSITION, light_position5);
	glLightfv(GL_LIGHT4, GL_SPOT_DIRECTION, direction5);
	glLightfv(GL_LIGHT4, GL_DIFFUSE, color5);
	glLightfv(GL_LIGHT4, GL_SPECULAR, color5);

	glLightfv(GL_LIGHT5, GL_POSITION, light_position6);
	glLightfv(GL_LIGHT5, GL_SPOT_DIRECTION, direction6);
	glLightfv(GL_LIGHT5, GL_DIFFUSE, color6);
	glLightfv(GL_LIGHT5, GL_SPECULAR, color6);

	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, ambient);

	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, material_specular);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, material_color);
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, material_ambient);
	glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, 120);

	glEnable(GL_LIGHTING);

	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHT1);
	glEnable(GL_LIGHT2);	

	glEnable(GL_LIGHT3);
	glEnable(GL_LIGHT4);
	glEnable(GL_LIGHT5);

	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LESS);

	glEnable(GL_POINT_SMOOTH);
	glHint(GL_POINT_SMOOTH_HINT, GL_NICEST);

	//glEnable(GL_LINE_SMOOTH);
	//glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);

	glHint(GL_POLYGON_SMOOTH_HINT, GL_NICEST);

	glLineWidth(0.5);
	glPointSize(5.0);

	//glEnable(GL_BLEND);
	//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); 
}

void CPolyTestView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	isRPressed = false;
	CView::OnRButtonUp(nFlags, point);
}

void CPolyTestView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	isRPressed = true;
	px = point.x;
	py = point.y;
	CView::OnRButtonDown(nFlags, point);
}

void CPolyTestView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	isLPressed = FALSE;

	CView::OnLButtonUp(nFlags, point);
}

void CPolyTestView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	isLPressed = TRUE;
	px = point.x;
	py = point.y;

	CView::OnLButtonDown(nFlags, point);
}

void CPolyTestView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	switch(nChar){
	case VK_UP:
		shift_z += 5;
		break;
	case VK_DOWN:
		shift_z -= 5;
		break;
	case VK_RIGHT:
		shift_x += 5;
		break;
	case VK_LEFT:
		shift_x -= 5;
		break;
	}
	CClientDC* dc = new CClientDC(this); 
	OnDraw(dc);
	delete dc;

	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CPolyTestView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if(isLPressed){
		int nx = point.x;
		int ny = point.y;
		
		Rz += (nx - px)/3;
		Ry += (ny - py)/3;
		px = nx;
		py = ny;
		CClientDC* dc = new CClientDC(this); 
		OnDraw(dc);
		delete dc;
	}
	else if(isRPressed){
		int nx = point.x;
		int ny = point.y;

		view_angle += (ny - py)/20.0f;
		px = nx;
		py = ny;
		CClientDC* dc = new CClientDC(this);

		RECT* rect = new RECT;
		GetClientRect(rect);
		OnSize(SIZE_RESTORED, rect->right, rect->bottom);
		delete rect;
		OnDraw(dc);
		delete dc;
	}

	CView::OnMouseMove(nFlags, point);
}

void CPolyTestView::wireFrame(MeshData *mesh)
{
	//CClientDC clientDC(this);
	//wglMakeCurrent(clientDC.m_hDC, m_hRC);

	int face_N = mesh->face_N;
	int (*face)[3] = mesh->face;
	float (*normal_f)[3] = mesh->normal_f;
	float (*normal)[3] = mesh->normal;
	float (*vertex)[3] = mesh->vertex;

	//glNewList(1, GL_COMPILE);
	glShadeModel(GL_SMOOTH);
	glDisable(GL_LIGHTING);
		
	//glColor3f(0.4f, 0.2f, 0.2f);
	glColor3f(0.0f, 0.0f, 0.0f);
	for(int i=0; i<face_N; i++){
		if(face[i][0] < 0)
			continue;

		if(face[i][0] > face[i][1]){
			float p1[3], p2[3];
			p1[0] = vertex[face[i][0]][0] + 0.01*normal[face[i][0]][0];
			p1[1] = vertex[face[i][0]][1] + 0.01*normal[face[i][0]][1];
			p1[2] = vertex[face[i][0]][2] + 0.01*normal[face[i][0]][2];

			p2[0] = vertex[face[i][1]][0] + 0.01*normal[face[i][1]][0];
			p2[1] = vertex[face[i][1]][1] + 0.01*normal[face[i][1]][1];
			p2[2] = vertex[face[i][1]][2] + 0.01*normal[face[i][1]][2];

			glBegin(GL_LINES);
				glVertex3fv(p1);
				glVertex3fv(p2);
			glEnd();
		}
	
		if(face[i][1] > face[i][2]){
			float p1[3], p2[3];
			p1[0] = vertex[face[i][1]][0] + 0.1*normal[face[i][1]][0];
			p1[1] = vertex[face[i][1]][1] + 0.1*normal[face[i][1]][1];
			p1[2] = vertex[face[i][1]][2] + 0.1*normal[face[i][1]][2];

			p2[0] = vertex[face[i][2]][0] + 0.1*normal[face[i][2]][0];
			p2[1] = vertex[face[i][2]][1] + 0.1*normal[face[i][2]][1];
			p2[2] = vertex[face[i][2]][2] + 0.1*normal[face[i][2]][2];

			glBegin(GL_LINES);
				glVertex3fv(p1);
				glVertex3fv(p2);
			glEnd();
		}

		if(face[i][2] > face[i][0]){
			float p1[3], p2[3];
			p1[0] = vertex[face[i][2]][0] + 0.1*normal[face[i][2]][0];
			p1[1] = vertex[face[i][2]][1] + 0.1*normal[face[i][2]][1];
			p1[2] = vertex[face[i][2]][2] + 0.1*normal[face[i][2]][2];

			p2[0] = vertex[face[i][0]][0] + 0.1*normal[face[i][0]][0];
			p2[1] = vertex[face[i][0]][1] + 0.1*normal[face[i][0]][1];
			p2[2] = vertex[face[i][0]][2] + 0.1*normal[face[i][0]][2];

			glBegin(GL_LINES);
				glVertex3fv(p1);
				glVertex3fv(p2);
			glEnd();
		}
	}
	/*
	glColor3f(1.0f, 1.0f, 1.0f);
	for(i=0; i<face_N; i++){
		if(face[i][0] < 0)
			continue;
		glBegin(GL_POLYGON);
			glNormal3fv(normal_f[i]);
			glVertex3fv(vertex[face[i][0]]);
			glVertex3fv(vertex[face[i][1]]);
			glVertex3fv(vertex[face[i][2]]);
		glEnd();
	}
	glEnable(GL_LIGHTING);*/
	//glEndList();

	//wglMakeCurrent(clientDC.m_hDC, NULL);
}

void CPolyTestView::draw()
{
	CClientDC* dc = new CClientDC(this); 
	OnDraw(dc);
	delete dc;
}

void CPolyTestView::drawFixedVertex(MeshData *mesh)
{
	int vertex_N = mesh->vertex_N;
	int face_N = mesh->face_N;
	int (*face)[3] = mesh->face;
	float (*normal_f)[3] = mesh->normal_f;
	float (*normal)[3] = mesh->normal;
	float (*vertex)[3] = mesh->vertex;

	//glNewList(1, GL_COMPILE);
	glShadeModel(GL_SMOOTH);
	glDisable(GL_LIGHTING);
		
	//glColor3f(0.4f, 0.2f, 0.2f);
	glColor3f(0.0f, 0.0f, 0.0f);
	for(int i=0; i<face_N; i++){
		if(face[i][0] < 0)
			continue;

		if(face[i][0] > face[i][1]){
			glBegin(GL_LINES);
				glVertex3fv(vertex[face[i][0]]);
				glVertex3fv(vertex[face[i][1]]);
			glEnd();
		}
	
		if(face[i][1] > face[i][2]){
			glBegin(GL_LINES);
				glVertex3fv(vertex[face[i][1]]);
				glVertex3fv(vertex[face[i][2]]);
			glEnd();
		}

		if(face[i][2] > face[i][0]){
			glBegin(GL_LINES);
				glVertex3fv(vertex[face[i][2]]);
				glVertex3fv(vertex[face[i][0]]);
			glEnd();
		}
	}
	glEnable(GL_LIGHTING);
	glColor3f(1.0f, 1.0f, 1.0f);
	float d = 0.05*view_angle/22.5;
		/*0.05*sqrt((eye[0] - shift_x)*(eye[0] - shift_x) 
		            + (eye[1] - shift_y)*(eye[1] - shift_y) 
					+ (eye[2] - shift_z)*(eye[2] - shift_z))/sqrt(eye[0]*eye[0] + eye[1]*eye[1] + eye[2]*eye[2]);*/
	for(i=0; i<face_N; i++){
		if(face[i][0] < 0)
			continue;
	
		float p1[3], p2[3], p3[3];

		p1[0] = vertex[face[i][0]][0] - d*normal[face[i][0]][0];
		p1[1] = vertex[face[i][0]][1] - d*normal[face[i][0]][1];
		p1[2] = vertex[face[i][0]][2] - d*normal[face[i][0]][2];

		p2[0] = vertex[face[i][1]][0] - d*normal[face[i][1]][0];
		p2[1] = vertex[face[i][1]][1] - d*normal[face[i][1]][1];
		p2[2] = vertex[face[i][1]][2] - d*normal[face[i][1]][2];

		p3[0] = vertex[face[i][2]][0] - d*normal[face[i][2]][0];
		p3[1] = vertex[face[i][2]][1] - d*normal[face[i][2]][1];
		p3[2] = vertex[face[i][2]][2] - d*normal[face[i][2]][2];

		glBegin(GL_POLYGON);
			glNormal3fv(normal_f[i]);
			glVertex3fv(p1);
			glVertex3fv(p2);
			glVertex3fv(p3);
		glEnd();
	}

	/*
	glPointSize(10);
	glColor3f(1.0f, 0.0f, 0.0f);
	glBegin(GL_POINTS);
	for(i=0; i<vertex_N; i++)
		if(mesh->isFixed[i])
			glVertex3fv(vertex[i]);
	glEnd();
	*/

	glEnable(GL_LIGHTING);
}


void CPolyTestView::drawBoundBox()
{
	glDisable(GL_LIGHTING);
	glLineWidth(5.0f);
	glColor3f(0,0,0);
	float p[][3] = {{20,20,20}, {-20,20,20}, {-20,-20,20}, {20,-20,20},
	{20,20,-20}, {-20,20,-20}, {-20,-20,-20}, {20,-20,-20}};
	int pair[][2] = {{0,1},{1,2},{2,3},{3,0},{4,5},{5,6},{6,7},{7,4},{0,4},{1,5},{2,6},{3,7}};
	for(int i=0; i<12; i++){
		glBegin(GL_LINES);
			glVertex3fv(p[pair[i][0]]);
			glVertex3fv(p[pair[i][1]]);
		glEnd();
	}
	glEnable(GL_LIGHTING);
}

void CPolyTestView::drawCenterGraph(MeshData* mesh)
{
	int vertex_N = mesh->vertex_N;
	int face_N = mesh->face_N;
	float (*center)[3] = mesh->center;
	int **link = mesh->vertex_link_f;
	int *degree = mesh->degree_f;
	float (*normal)[3] = mesh->normal;
	float (*vertex)[3] = mesh->vertex;
	int i;

	glShadeModel(GL_SMOOTH);
	glDisable(GL_LIGHTING);
	
	glColor3f(0.0f, 0.0f, 0.0f);
	glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	for(i=0; i<vertex_N; i++){
		int* l = link[i];
		int deg = degree[i];
		glBegin(GL_POLYGON);
		for(int j=0; j<deg; j++){
			glVertex3fv(center[l[j]]);
		}
		glEnd();
		/*
		for(int j=0; j<deg; j++){
			glBegin(GL_POLYGON);
			glVertex3fv(vertex[i]);
			glVertex3fv(center[l[j]]);
			glVertex3fv(center[l[(j+1)%deg]]);
			glEnd();
		}*/
	}

	/*
	glColor3f(0.0f, 0.0f, 1.0f);
	glPointSize(10.0f);
	glBegin(GL_POINTS);
	for(i=0; i<vertex_N; i++)
		glVertex3fv(vertex[i]);
	glEnd();*/

	/*
	glColor3f(1.0f, 0.0f, 0.0f);
	glPointSize(3.0f);
	glBegin(GL_POINTS);
	for(i=0; i<face_N; i++)
		glVertex3fv(center[i]);
	glEnd();
	*/

	glEnable(GL_LIGHTING);
	float d = 0.05*view_angle/22.5;
	float (*normal_f)[3] = mesh->normal_f;
	glColor3f(1.0f, 1.0f, 1.0f);
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	for(i=0; i<vertex_N; i++){	
		int* l = link[i];
		int deg = degree[i];

		glBegin(GL_POLYGON);
		glNormal3fv(normal[i]);
		for(int j=0; j<deg; j++){
			float p[3];
			p[0] = center[l[j]][0] - d*normal_f[l[j]][0];
			p[1] = center[l[j]][1] - d*normal_f[l[j]][1];
			p[2] = center[l[j]][2] - d*normal_f[l[j]][2];
			glVertex3fv(p);
		}
		glEnd();

		/*
		for(int j=0; j<deg; j++){
			glBegin(GL_POLYGON);
		
			glNormal3fv(normal[i]);

			float p0[3];
			p0[0] = vertex[i][0] - 0.05*normal[i][0];
			p0[1] = vertex[i][1] - 0.05*normal[i][1];
			p0[2] = vertex[i][2] - 0.05*normal[i][2];

			glVertex3fv(p0);

			float p1[3];
			p1[0] = center[l[j]][0] - 0.05*normal_f[l[j]][0];
			p1[1] = center[l[j]][1] - 0.05*normal_f[l[j]][1];
			p1[2] = center[l[j]][2] - 0.05*normal_f[l[j]][2];
			glVertex3fv(p1);

			float p2[3];
			p2[0] = center[l[(j+1)%deg]][0] - 0.05*normal_f[l[(j+1)%deg]][0];
			p2[1] = center[l[(j+1)%deg]][1] - 0.05*normal_f[l[(j+1)%deg]][1];
			p2[2] = center[l[(j+1)%deg]][2] - 0.05*normal_f[l[(j+1)%deg]][2];
			glVertex3fv(p2);

			glEnd();
		}	*/
	}
	glEnable(GL_LIGHTING);
}

void CPolyTestView::drawSqrt3(MeshData *mesh)
{
	int vertex_N = mesh->vertex_N;
	int face_N = mesh->face_N;
	float (*center)[3] = mesh->center;
	int **link = mesh->vertex_link_f;
	int *degree = mesh->degree_f;
	float (*normal)[3] = mesh->normal;
	float (*vertex)[3] = mesh->vertex;

	int i;

	glShadeModel(GL_SMOOTH);

	float (*normal_f)[3] = mesh->normal_f;
	glColor3f(1.0f, 1.0f, 1.0f);
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	for(i=0; i<vertex_N; i++){	
		int* l = link[i];
		int deg = degree[i];
		for(int j=0; j<deg; j++){
			glBegin(GL_POLYGON);
		
			float v1[3], v2[3];
			MeshData::VEC(v1, vertex[i], center[l[j]]);
			MeshData::VEC(v2, vertex[i], center[l[(j+1)%deg]]);

			float n[3];
			MeshData::CROSS(n, v1, v2);
			double len = MeshData::LENGTH(n);
			if(len == 0)
				continue;
			n[0] /= len;
			n[1] /= len;
			n[2] /= len;

			glNormal3fv(n);
			glVertex3fv(vertex[i]);
			glVertex3fv(center[l[j]]);
			glVertex3fv(center[l[(j+1)%deg]]);

			glEnd();
		}	
	}
}
