// Subdivider.h: Subdivider NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SUBDIVIDER_H__1168D90D_29F3_455D_8C32_4302007876E6__INCLUDED_)
#define AFX_SUBDIVIDER_H__1168D90D_29F3_455D_8C32_4302007876E6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "vtkImplicitFunction.h"
#include "MeshData.h"

#define PI 3.14159265358979

class Subdivider  
{
public:
	MeshData* mesh;
	int new_vertex_N;
	int new_face_N;
	int (*new_face)[3];
	float (*new_vertex)[3];
	int (*vertex_index)[3];

public:
	void subdivideInside(vtkImplicitFunction *func);
	void subdivideCurvedFace(vtkImplicitFunction* func, float T);
	void butterfly();
	void LOOP();
	void linear();
	void setMeshData(MeshData* mesh);
	Subdivider();
	virtual ~Subdivider();

protected:
	void updateMesh();
	void subdivideTopology(BOOL* flag);
};

#endif // !defined(AFX_SUBDIVIDER_H__1168D90D_29F3_455D_8C32_4302007876E6__INCLUDED_)
